<template>
  <v-container>
    <br />
    <v-alert v-if="isPayed" type="success"
      >Cool your paiement was successfuly Submit. Please see order status page for see order status.</v-alert
    >
    <v-alert v-if="!isPayed && cart.length === 0" type="warning"
      >No Items selected.</v-alert
    >
    <v-stepper v-model="e1" v-if="cart.length > 0">
      <v-stepper-header>
        <v-stepper-step :complete="e1 > 1" step="1"> Cart </v-stepper-step>

        <v-divider></v-divider>

        <v-stepper-step :complete="e1 > 2" step="2"> Paiement </v-stepper-step>

        <v-divider></v-divider>

        <v-stepper-step step="3"> Confirmation </v-stepper-step>
      </v-stepper-header>
      <v-stepper-items>
        <v-stepper-content step="1">
          <v-simple-table>
            <template v-slot:default>
              <thead>
                <tr>
                  <th class="text-left">Id</th>
                  <th class="text-left">price</th>
                  <th class="text-left">quantity</th>
                  <th class="text-left">sum</th>
                </tr>
              </thead>
              <tbody>
                <tr v-for="item in cart" :key="item.product_code">
                  <td>{{ item.id }}</td>
                  <td v-if="item.product.price === item.price">{{ item.product.price }} €</td>
                  <td v-else><del>{{ item.product.price }} €</del> {{ item.price }} € </td>
                  <td>{{ item.quantity }}</td>
                  <td>{{ item.quantity * item.price }} €</td>
                </tr>
                <tr>
                  <td></td>
                  <td></td>
                  <td>Total</td>
                  <td>{{getSumPrice()}} €</td>
                </tr>
              </tbody>
            </template>
          </v-simple-table>
          <v-btn
            v-on:click="
              () => {
                this.e1 = 2;
              }
            "
            >Make Paiement</v-btn
          >
          <v-btn
            v-on:click="
              () => {
                this.cart = [];
              }
            "
            v-if="cart.length > 0"
            >Delete cart</v-btn
          >
        </v-stepper-content>
        <v-stepper-content step="2">
          <v-form v-model="valid">
            <v-container>
              <v-row>
                <v-col cols="12" md="4">
                  <v-text-field
                    v-model="firstname"
                    :rules="nameRules"
                    label="First name"
                    required
                  ></v-text-field>
                </v-col>

                <v-col cols="12" md="4">
                  <v-text-field
                    v-model="lastname"
                    :rules="nameRules"
                    label="Last name"
                    required
                  ></v-text-field>
                </v-col>
              </v-row>
              <v-row>
                <v-col cols="12" md="4">
                  <v-text-field
                    v-model="card"
                    :rules="cardRules"
                    label="Card number"
                    :counter="16"
                    required
                  ></v-text-field>
                </v-col>
                <v-col cols="12" md="4">
                  <v-text-field
                    v-model="date"
                    :rules="dateRules"
                    label="Validity date MM-YY"
                    required
                  ></v-text-field>
                </v-col>
                <v-col cols="12" md="4">
                  <v-text-field
                    v-model="cvc"
                    :rules="cvcRules"
                    label="CVC"
                    :counter="3"
                    required
                  ></v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-form>
          <v-btn
            v-on:click="
              () => {
                if (this.valid) {
                  this.e1 = 3;
                } else {
                  this.badform = true;
                }
              }
            "
            >Next</v-btn
          >
          <v-btn
            v-on:click="
              () => {
                this.e1 = 1;
              }
            "
            >Return</v-btn
          >
        </v-stepper-content>
        <v-stepper-content step="3">
          <v-simple-table>
            <template v-slot:default>
              <thead>
                <tr>
                  <th class="text-left">Id</th>
                  <th class="text-left">price</th>
                  <th class="text-left">quantity</th>
                  <th class="text-left">sum</th>
                </tr>
              </thead>
              <tbody>
                <tr v-for="item in cart" :key="item.product_code">
                  <td>{{ item.id }}</td>
                  <td>{{ item.price }} €</td>
                  <td>{{ item.quantity }}</td>
                  <td>{{ item.quantity * item.price }} €</td>
                </tr>
                <tr>
                  <td></td>
                  <td></td>
                  <td>Total</td>
                  <td>{{getSumPrice()}} €</td>
                </tr>
              </tbody>
            </template>
          </v-simple-table>
          <v-form v-model="valid">
            <v-container>
              <v-row>
                <v-col cols="12" md="4">
                  <v-text-field
                    v-model="firstname"
                    :rules="nameRules"
                    label="First name"
                    required
                    readonly
                  ></v-text-field>
                </v-col>

                <v-col cols="12" md="4">
                  <v-text-field
                    v-model="lastname"
                    :rules="nameRules"
                    label="Last name"
                    required
                    readonly
                  ></v-text-field>
                </v-col>
              </v-row>
              <v-row>
                <v-col cols="12" md="4">
                  <v-text-field
                    v-model="card"
                    :rules="cardRules"
                    label="Card number"
                    :counter="16"
                    required
                    readonly
                  ></v-text-field>
                </v-col>
                <v-col cols="12" md="4">
                  <v-text-field
                    v-model="date"
                    :rules="dateRules"
                    label="Validity date Format"
                    required
                    readonly
                  ></v-text-field>
                </v-col>
                <v-col cols="12" md="4">
                  <v-text-field
                    v-model="cvc"
                    :rules="cvcRules"
                    label="CVC"
                    :counter="3"
                    required
                    readonly
                  ></v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-form>
          <v-btn
            v-on:click="processPaiement" >Comfirm order</v-btn
          >
          <v-btn
            v-on:click="
              () => {
                this.cart = [];
              }
            "
            v-if="cart.length > 0"
            >abort</v-btn
          >
        </v-stepper-content>
      </v-stepper-items>
    </v-stepper>
    <v-snackbar v-model="badform"
      >You need to complete form for going next
      <template v-slot:action="{ attrs }">
        <v-btn color="pink" text v-bind="attrs" @click="badform = false">
          Close
        </v-btn>
      </template>
    </v-snackbar>
  </v-container>
</template>

<script>
import axios from "axios";

export default {
  name: "Cart",
  components: {},
  data: () => ({
    cart: [],
    isPayed: false,
    e1: 1,
    valid: false,
    badform: false,
    firstname: "",
    lastname: "",
    nameRules: [(v) => !!v || "Name is required"],
    card: "",
    cardRule: [
      (v) => !!v || "Card number is required",
      (v) => {
        if (v.include(" ")) {
          return "Please don't write space";
        }
        return /[0-9]+/.test(v) || "Write only number";
      },
    ],
    date: "",
    dateRule: [
      (v) => !!v || "E-mail is required",
      (v) => /.+\/.+ /.test(v) || "Invalid date format (MM/YYYY)",
    ],
    cvc: "",
    cvcRule: [
      (v) => !!v || "E-mail is required",
      (v) => /[0-9][0-9][0-9]/.test(v) || "Invalid cvc",
    ],
  }),
  mounted() {
    if (localStorage.cart) {
      this.cart = JSON.parse(localStorage.cart);
    }
  },
  watch: {
    cart: function () {
      console.log("setCart");
      localStorage.cart = JSON.stringify(this.cart);
    },
  },
  methods: {
    getSumPrice: function() {
      let sumPrice = 0;
      this.cart.forEach((element) => {
        sumPrice += element.price * element.quantity;
      });
      return sumPrice;
    },
    processPaiement: function () {
      if (this.cart.length > 0 && confirm("Make Paiement ?")) {
        let sumPrice = 0;
        this.cart.forEach((element) => {
          sumPrice += element.price * element.quantity;
        });
        const productList = this.cart.map((value) => ({
          product_code: value.id,
          price: value.price,
          quantity: value.quantity,
        }));
        axios
          .post(process.env.VUE_APP_URL_E_COMMERCE + "/order/add", {
            order: {
              client_id: 1,
              products: productList,
              sum_price: sumPrice,
              delivery_address_id: 1,
              invoice_address_id: 1,
              credit_card: {
                first_name: this.firstname,
                last_name: this.lastname,
                card_number: this.card,
                validity_date: this.date,
                CCV: this.cvc,
                provider: 'visa'
              }
            },
          })
          .then((response) => {
            if (response.data.isSucess === true) {
              this.isPayed = true;
              this.cart = [];
            } else {
              alert(response.data.message);
            }
          })
          .catch((e) => {
            alert("Error : " + e);
          });
      }
    },
  },
};
</script>

